# Directories
BIN_DIR := bin
OBJ_DIR := obj
INC_DIR := include
SRC_DIR := src

# Files
HEADERS := $(wildcard $(INC_DIR)/*.h)
OBJFILES := $(OBJ_DIR)/Common.o

# Executables
CLIENTS := Client_INET_Stream Client_INET6_Stream Client_UNIX_Stream
CLIENT_EXECS := $(addprefix $(BIN_DIR)/, $(CLIENTS))

# Flags
CFLAGS := -Wall -pedantic -Werror -Wextra -Wconversion -std=gnu11
LIBS := -lsqlite3 -lrt

all: $(CLIENT_EXECS)

$(BIN_DIR)/%: $(OBJ_DIR)/%.o $(OBJFILES) | $(BIN_DIR)
	gcc -o $@ $^ $(LIBS)

$(OBJ_DIR)/%.o: $(SRC_DIR)/%.c $(HEADERS) | $(OBJ_DIR)
	gcc -c $(CFLAGS) -I$(INC_DIR) $< -o $@

$(BIN_DIR):
	mkdir -p $(BIN_DIR)

$(OBJ_DIR):
	mkdir -p $(OBJ_DIR)

INET_test:
	./bin/Client_INET_Stream 127.0.0.1 1800 mensaje 10 250000

test_INET6:
	./bin/Client_INET6_Stream ::1 1800 enp2s0 mensaje 10 250000 &

UNIX_test:
	./bin/Client_UNIX_Stream /home/$(USER)/UNIX_ICP/ mensaje 10 250000 &

Full_test: 
	./bashCode.sh

clean:
	rm -rf bin/* obj/*